﻿<?php
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Landing page of Organization Manager View (Approvels)
 *
 * @package    enrol_aqayepardakht
 * @copyright  2021 aqayepardakht<aqayepardakht.ir>
 * @author     aqayepardakht
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
require_once( dirname( __FILE__ ) . '/../../config.php' );
require_once( "lib.php" );
global $CFG, $_SESSION, $USER, $DB;

$systemcontext = context_system::instance();
$PAGE->set_context( $systemcontext );
$plugininstance = new enrol_aqayepardakht_plugin();
if ( !empty( $_POST[ 'multi' ] ) ) {
  $instance_array = unserialize( $_POST[ 'instances' ] );
  $ids_array = unserialize( $_POST[ 'ids' ] );
  $_SESSION[ 'idlist' ] = implode( ',', $ids_array );
  $_SESSION[ 'inslist' ] = implode( ',', $instance_array );
  $_SESSION[ 'multi' ] = $_POST[ 'multi' ];
} else {
  $_SESSION[ 'courseid' ] = $_POST[ 'course_id' ];
  $_SESSION[ 'instanceid' ] = $_POST[ 'instance_id' ];
}
$_SESSION[ 'totalcost' ] = $_POST[ 'amount' ];
$_SESSION[ 'userid' ] = $USER->id;
$Price = $_POST[ 'amount' ];

$MerchantID = $plugininstance->get_config( 'merchant_id' );
$testing = $plugininstance->get_config( 'checkproductionmode' );
$use_aqayepardakht = $plugininstance->get_config( 'useaqayepardakht' );
$ReturnPath = $CFG->wwwroot . '/enrol/aqayepardakht/verify.php';
$ResNumber = date( 'YmdHis' ); // Order Id In Your System
$Description = 'پرداخت شهریه ' . $_POST[ 'item_name' ] . ' | توسط:  ' . $USER->firstname . ' ' . $USER->lastname . ' | ایمیل : ' . $USER->email . ' | موبایل : ' . $USER->phone2;
$Mobile = $USER->phone2;

if ( $testing == 0 ) {
  $MerchantID = "aqayepardakht";
}


$parameters = [
  "pin" => $MerchantID,
  "amount" => intval( $Price ) / 10,
  "callback" => $ReturnPath,
  "invoice_id" => $ResNumber,
  "description" => $Description,
  "mobile" => $Mobile
];

$parameters = json_encode( $parameters );
$ch = curl_init( 'https://panel.aqayepardakht.ir/api/create' );
curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
curl_setopt( $ch, CURLINFO_HEADER_OUT, true );
curl_setopt( $ch, CURLOPT_POST, true );
curl_setopt( $ch, CURLOPT_POSTFIELDS, $parameters );

curl_setopt( $ch, CURLOPT_HTTPHEADER, array(
  'Content-Type: application/json',
  'Content-Length: ' . strlen( $parameters ) ) );
$res = curl_exec( $ch );
curl_close( $ch );


if ( $res && !is_numeric( $res ) ) {
  Header( 'Location: https://panel.aqayepardakht.ir/startpay/' . $res );
} else {
  echo 'ERR: ' . $res;

}